ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.9 by root, Tue Dec 7 20:03:15 2010 UTC vs.
Revision 1.22 by root, Wed Dec 15 00:17:48 2010 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11
12# perl build variables 10# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
13PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 17
19ARCH="$(uname -m)" 18ARCH="$(uname -m)"
20 19
21case "$ARCH" in 20case "$ARCH" in
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 36
38# some configuration options for modules 37# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 38export PERL_MM_USE_DEFAULT=1
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
52postconfigure() { : ; } 51postconfigure() { : ; }
53postbuild() { : ; } 52postbuild() { : ; }
54postinstall() { : ; } 53postinstall() { : ; }
55 54
56# now source user config, if any 55# now source user config, if any
56if [ "$STATICPERLRC" ]; then
57 . "$STATICPERLRC"
58else
57[ -r /etc/staticperlrc ] && . /etc/staticperlrc 59 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
58[ -r ~/.staticperlrc ] && . ~/.staticperlrc 60 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
59[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 61 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
62fi
60 63
61############################################################################# 64#############################################################################
62# support 65# support
66
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
71export LC_ALL=C # just to be on the safe side
63 72
64# set version in a way that Makefile.PL can extract 73# set version in a way that Makefile.PL can extract
65VERSION=VERSION; eval \ 74VERSION=VERSION; eval \
66$VERSION=0.1 75$VERSION=0.912
67 76
68BZ2=bz2 77BZ2=bz2
69BZIP2=bzip2 78BZIP2=bzip2
70 79
71fatal() { 80fatal() {
104############################################################################# 113#############################################################################
105# clean 114# clean
106 115
107distclean() { 116distclean() {
108 verblock <<EOF 117 verblock <<EOF
109deleting everything installed by this script 118 deleting everything installed by this script (rm -rf $STATICPERL)
110EOF 119EOF
111 120
112 rm -rf "$STATICPERL" 121 rm -rf "$STATICPERL"
113} 122}
114 123
139 148
140 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 149 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
141 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 150 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
142 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 151 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
143 || fatal "$URL: unable to download" 152 || fatal "$URL: unable to download"
153 rm -f perl-$PERL_VERSION.tar.$BZ2
144 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 154 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
145 fi 155 fi
146 156
147 verblock <<EOF 157 verblock <<EOF
148unpacking perl 158unpacking perl
149EOF 159EOF
150 160
151 mkdir -p unpack 161 mkdir -p unpack
162 rm -rf unpack/perl-$PERL_VERSION
152 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xC unpack \ 163 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
153 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 164 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
154 chmod -R u+w unpack/perl-$PERL_VERSION 165 chmod -R u+w unpack/perl-$PERL_VERSION
155 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 166 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
156 rmdir -p unpack 167 rmdir -p unpack
157 fi 168 fi
158} 169}
159 170
160# similar to GNU-sed -i or perl -pi 171# similar to GNU-sed -i or perl -pi
161sedreplace() { 172sedreplace() {
162 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 173 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
174 rm -f "$2"
163 mv "$2~" "$2" 175 mv "$2~" "$2"
176}
177
178configure_failure() {
179 cat <<EOF
180
181
182***
183*** Configure failed - see above for the exact error message(s).
184***
185*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
186*** flags are not supported by your compiler. Less often, this is because
187*** PERL_LIBS either contains a library not available on your system (such as
188*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
189***
190*** You can provide your own flags by creating a ~/.staticperlrc file with
191*** variable assignments. For example (these are the actual values used):
192***
193
194PERL_CC="$PERL_CC"
195PERL_CCFLAGS="$PERL_CCFLAGS"
196PERL_OPTIMIZE="$PERL_OPTIMIZE"
197PERL_LDFLAGS="$PERL_LDFLAGS"
198PERL_LIBS="$PERL_LIBS"
199
200EOF
201 exit 1
164} 202}
165 203
166configure() { 204configure() {
167 fetch 205 fetch
168 206
174configuring $STATICPERL/src/perl-$PERL_VERSION 212configuring $STATICPERL/src/perl-$PERL_VERSION
175EOF 213EOF
176 214
177 rm -f "$PERL_PREFIX/staticstamp.install" 215 rm -f "$PERL_PREFIX/staticstamp.install"
178 216
179 make distclean >/dev/null 2>&1 217 "$MAKE" distclean >/dev/null 2>&1
180 218
181 # I hate them 219 # I hate them
182 grep -q -- -fstack-protector Configure && \ 220 grep -q -- -fstack-protector Configure && \
183 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 221 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
184 222
190 -Dusemymalloc=n \ 228 -Dusemymalloc=n \
191 -Uusedl \ 229 -Uusedl \
192 -Uusethreads \ 230 -Uusethreads \
193 -Uuseithreads \ 231 -Uuseithreads \
194 -Uusemultiplicity \ 232 -Uusemultiplicity \
195 -Duseperlio \
196 -Uusesfio \ 233 -Uusesfio \
197 -Uuseshrplib \ 234 -Uuseshrplib \
198 -Dcppflags="$PERL_CPPFLAGS" \ 235 -A ccflags=" $PERL_CCFLAGS" \
199 -Dccflags="-g2 -fno-strict-aliasing" \ 236 -Dcc="$PERL_CC" \
200 -Doptimize="$PERL_OPTIMIZE" \ 237 -Doptimize="$PERL_OPTIMIZE" \
201 -Dldflags="$PERL_LDFLAGS" \ 238 -Dldflags="$PERL_LDFLAGS" \
202 -Dlibs="$PERL_LIBS" \ 239 -Dlibs="$PERL_LIBS" \
203 -Dprefix="$PERL_PREFIX" \ 240 -Dprefix="$PERL_PREFIX" \
204 -Dbin="$PERL_PREFIX/bin" \ 241 -Dbin="$PERL_PREFIX/bin" \
215 -Dpager=/usr/bin/less \ 252 -Dpager=/usr/bin/less \
216 -Demail="$EMAIL" \ 253 -Demail="$EMAIL" \
217 -Dcf_email="$EMAIL" \ 254 -Dcf_email="$EMAIL" \
218 -Dcf_by="$EMAIL" \ 255 -Dcf_by="$EMAIL" \
219 $PERL_CONFIGURE \ 256 $PERL_CONFIGURE \
257 -Duseperlio \
220 -dE || fatal "Configure failed" 258 -dE || configure_failure
221 259
222 sedreplace ' 260 sedreplace '
223 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 261 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
224 s/ *-fno-stack-protector */ /g 262 s/ *-fno-stack-protector */ /g
225 ' config.sh 263 ' config.sh
240building $STATICPERL/src/perl-$PERL_VERSION 278building $STATICPERL/src/perl-$PERL_VERSION
241EOF 279EOF
242 280
243 rm -f "$PERL_PREFIX/staticstamp.install" 281 rm -f "$PERL_PREFIX/staticstamp.install"
244 282
245 make || fatal "make: error while building perl" 283 "$MAKE" || fatal "make: error while building perl"
246 284
247 postbuild || fatal "postbuild hook failed" 285 postbuild || fatal "postbuild hook failed"
248} 286}
249 287
250install() { 288install() {
254 verblock <<EOF 292 verblock <<EOF
255installing $STATICPERL/src/perl-$PERL_VERSION 293installing $STATICPERL/src/perl-$PERL_VERSION
256to $PERL_PREFIX 294to $PERL_PREFIX
257EOF 295EOF
258 296
259 rm -rf "$PERL_PREFIX" 297 ln -sf "perl/bin/" "$STATICPERL/bin"
260 298 ln -sf "perl/lib/" "$STATICPERL/lib"
299
300 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
301 rm -rf "$PERL_PREFIX" # by this rm -rf
302
261 make install || fatal "make install: error while installing" 303 "$MAKE" install || fatal "make install: error while installing"
262 304
263 rcd "$PERL_PREFIX" 305 rcd "$PERL_PREFIX"
264 306
265 # create a "make install" replacement for CPAN 307 # create a "make install" replacement for CPAN
266 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 308 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
267make install UNINST=1 309"$MAKE" || exit
310
268if find blib/arch/auto -type f | grep -q -v .exists; then 311if find blib/arch/auto -type f | grep -q -v .exists; then
269 echo Probably an XS module, rebuilding perl 312 echo Probably an XS module, rebuilding perl
270 make perl 313 if "$MAKE" perl; then
314 mv perl "$PERL_PREFIX"/bin/perl~ \
271 rm -f "$PERL_PREFIX"/bin/perl 315 && rm -f "$PERL_PREFIX"/bin/perl \
272 make -f Makefile.aperl inst_perl 316 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
273 make -f Makefile.aperl map_clean 317 "$MAKE" -f Makefile.aperl map_clean
318 else
319 "$MAKE" -f Makefile.aperl map_clean
320 exit 1
321 fi
274fi 322fi
323
324"$MAKE" install UNINST=1
275EOF 325EOF
276 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 326 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
277 327
278 # trick CPAN into avoiding ~/.cpan completely 328 # trick CPAN into avoiding ~/.cpan completely
279 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 329 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
294 ' || fatal "error while initialising CPAN" 344 ' || fatal "error while initialising CPAN"
295 345
296 touch "$PERL_PREFIX/staticstamp.install" 346 touch "$PERL_PREFIX/staticstamp.install"
297 fi 347 fi
298 348
299 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall"; then 349 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
300 NOCHECK_INSTALL=+ 350 NOCHECK_INSTALL=+
301 instcpan $STATICPERL_MODULES 351 instcpan $STATICPERL_MODULES
302 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 352 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
303 353
304 postinstall || fatal "postinstall hook failed" 354 postinstall || fatal "postinstall hook failed"
339 for mod in "$@"; do 389 for mod in "$@"; do
340 echo 390 echo
341 echo $mod 391 echo $mod
342 ( 392 (
343 rcd $mod 393 rcd $mod
344 make -f Makefile.aperl map_clean >/dev/null 2>&1 394 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
345 make distclean >/dev/null 2>&1 395 "$MAKE" distclean >/dev/null 2>&1
346 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 396 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
347 make || fatal "$mod: error building module" 397 "$MAKE" || fatal "$mod: error building module"
348 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 398 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
349 make distclean >/dev/null 2>&1 399 "$MAKE" distclean >/dev/null 2>&1
350 exit 0 400 exit 0
351 ) || exit $? 401 ) || exit $?
352 done 402 done
353} 403}
354 404
355############################################################################# 405#############################################################################
356# main 406# main
357 407
358podusage() { 408podusage() {
359 echo 409 echo
410
360 if [ -e "$PERL_PREFIX/bin/perl" ]; then 411 if [ -e "$PERL_PREFIX/bin/perl" ]; then
361 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 412 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
362 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 413 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
363 2>/dev/null && exit 414 2>/dev/null && exit
364 fi 415 fi
416
365 # try whatever perl we can find 417 # try whatever perl we can find
366 perl -MPod::Usage -e \ 418 perl -MPod::Usage -e \
367 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 419 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
368 2>/dev/null && exit 420 2>/dev/null && exit
369 421
370 fatal "displaying documentation requires a working perl - try '$0 install' first" 422 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
371} 423}
372 424
373usage() { 425usage() {
374 podusage 0 426 podusage 0
375} 427}
385} 437}
386 438
387bundle() { 439bundle() {
388 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 440 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
389 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 441 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
442 CACHE="$STATICPERL/cache"
443 mkdir -p "$CACHE"
390 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 444 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
391} 445}
392 446
393if [ $# -gt 0 ]; then 447if [ $# -gt 0 ]; then
394 while [ $# -gt 0 ]; do 448 while [ $# -gt 0 ]; do
395 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 449 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
396 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 450 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
397 451
398 command="${1#--}"; shift 452 command="${1#--}"; shift
399 case "$command" in 453 case "$command" in
454 version )
455 echo "staticperl version $VERSION"
456 ;;
400 fetch | configure | build | install | clean | distclean) 457 fetch | configure | build | install | clean | distclean)
401 verblock <<EOF
402$command
403EOF
404 ( "$command" ) 458 ( "$command" ) || exit
405 ;; 459 ;;
406 instsrc ) 460 instsrc )
407 ( instsrc "$@" ) 461 ( instsrc "$@" ) || exit
408 exit 462 exit
409 ;; 463 ;;
410 instcpan ) 464 instcpan )
411 ( instcpan "$@" ) 465 ( instcpan "$@" ) || exit
412 exit 466 exit
413 ;; 467 ;;
414 cpan ) 468 cpan )
415 ( install ) 469 ( install ) || exit
416 "$PERL_PREFIX/bin/cpan" "$@" 470 "$PERL_PREFIX/bin/cpan" "$@"
417 exit 471 exit
418 ;; 472 ;;
419 mkbundle ) 473 mkbundle )
420 ( install ) 474 ( install ) || exit
421 bundle "$@" 475 bundle "$@"
422 exit 476 exit
423 ;; 477 ;;
424 mkperl ) 478 mkperl )
425 ( install ) 479 ( install ) || exit
426 bundle --perl "$@" 480 bundle --perl "$@"
481 exit
482 ;;
483 mkapp )
484 ( install ) || exit
485 bundle --app "$@"
427 exit 486 exit
428 ;; 487 ;;
429 help ) 488 help )
430 podusage 2 489 podusage 2
431 ;; 490 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines